"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NestableScrollContainer = NestableScrollContainer;

var _react = _interopRequireDefault(require("react"));

var _reactNativeGestureHandler = require("react-native-gesture-handler");

var _reactNativeReanimated = _interopRequireWildcard(require("react-native-reanimated"));

var _nestableScrollContainerContext = require("../context/nestableScrollContainerContext");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const AnimatedScrollView = _reactNativeReanimated.default.createAnimatedComponent(_reactNativeGestureHandler.ScrollView);

function NestableScrollContainerInner(props) {
  const {
    outerScrollOffset,
    containerSize,
    scrollViewSize,
    scrollableRef,
    outerScrollEnabled
  } = (0, _nestableScrollContainerContext.useSafeNestableScrollContainerContext)();
  const onScroll = (0, _reactNativeReanimated.useAnimatedScrollHandler)({
    onScroll: _ref => {
      let {
        contentOffset
      } = _ref;
      outerScrollOffset.value = contentOffset.y;
    }
  });
  return /*#__PURE__*/_react.default.createElement(AnimatedScrollView, _extends({}, props, {
    onLayout: _ref2 => {
      let {
        nativeEvent: {
          layout
        }
      } = _ref2;
      containerSize.value = layout.height;
    },
    onContentSizeChange: (w, h) => {
      var _props$onContentSizeC;

      scrollViewSize.value = h;
      (_props$onContentSizeC = props.onContentSizeChange) === null || _props$onContentSizeC === void 0 ? void 0 : _props$onContentSizeC.call(props, w, h);
    },
    scrollEnabled: outerScrollEnabled,
    ref: scrollableRef,
    scrollEventThrottle: 1,
    onScroll: onScroll
  }));
}

function NestableScrollContainer(props) {
  return /*#__PURE__*/_react.default.createElement(_nestableScrollContainerContext.NestableScrollContainerProvider, null, /*#__PURE__*/_react.default.createElement(NestableScrollContainerInner, props));
}
//# sourceMappingURL=NestableScrollContainer.js.map