"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _reactNativeReanimated = _interopRequireWildcard(require("react-native-reanimated"));

var _animatedValueContext = require("../context/animatedValueContext");

var _draggableFlatListContext = require("../context/draggableFlatListContext");

var _refContext = require("../context/refContext");

var _utils = require("../utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function PlaceholderItem(_ref) {
  var _propsRef$current;

  let {
    renderPlaceholder
  } = _ref;
  const [size, setSize] = (0, _react.useState)(0);
  const {
    activeCellSize,
    placeholderOffset,
    spacerIndexAnim,
    horizontalAnim,
    scrollOffset
  } = (0, _animatedValueContext.useAnimatedValues)();
  const {
    keyToIndexRef,
    propsRef
  } = (0, _refContext.useRefs)();
  const {
    activeKey,
    horizontal
  } = (0, _draggableFlatListContext.useDraggableFlatListContext)(); // Size does not seem to be respected when it is an animated style

  (0, _reactNativeReanimated.useAnimatedReaction)(() => {
    return activeCellSize.value;
  }, (cur, prev) => {
    if (cur !== prev) {
      (0, _reactNativeReanimated.runOnJS)(setSize)(cur);
    }
  });
  const activeIndex = activeKey ? keyToIndexRef.current.get(activeKey) : undefined;
  const activeItem = activeIndex === undefined ? null : (_propsRef$current = propsRef.current) === null || _propsRef$current === void 0 ? void 0 : _propsRef$current.data[activeIndex];
  const animStyle = (0, _reactNativeReanimated.useAnimatedStyle)(() => {
    const offset = placeholderOffset.value - scrollOffset.value;
    return {
      opacity: size >= 0 ? 1 : 0,
      overflow: 'hidden',
      transform: [horizontalAnim.value ? {
        translateX: offset
      } : {
        translateY: offset
      }]
    };
  }, [spacerIndexAnim, placeholderOffset, horizontalAnim, scrollOffset, size]);
  const extraStyle = (0, _react.useMemo)(() => {
    return horizontal ? {
      width: size
    } : {
      height: size
    };
  }, [horizontal, size]);
  return /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    pointerEvents: activeKey ? "auto" : "none",
    style: [_reactNative.StyleSheet.absoluteFill, animStyle, extraStyle]
  }, !activeItem || activeIndex === undefined ? null : renderPlaceholder === null || renderPlaceholder === void 0 ? void 0 : renderPlaceholder({
    item: activeItem,
    index: activeIndex
  }));
}

var _default = (0, _utils.typedMemo)(PlaceholderItem);

exports.default = _default;
//# sourceMappingURL=PlaceholderItem.js.map