"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reactNativeReanimated = require("react-native-reanimated");

var _utils = require("../utils");

const ScrollOffsetListener = _ref => {
  let {
    scrollOffset,
    onScrollOffsetChange
  } = _ref;
  (0, _reactNativeReanimated.useAnimatedReaction)(() => {
    return scrollOffset.value;
  }, (cur, prev) => {
    if (cur !== prev) {
      (0, _reactNativeReanimated.runOnJS)(onScrollOffsetChange)(cur);
    }
  }, [scrollOffset]);
  return null;
};

var _default = (0, _utils.typedMemo)(ScrollOffsetListener);

exports.default = _default;
//# sourceMappingURL=ScrollOffsetListener.js.map