"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NestableScrollContainerProvider = NestableScrollContainerProvider;
exports.useNestableScrollContainerContext = useNestableScrollContainerContext;
exports.useSafeNestableScrollContainerContext = useSafeNestableScrollContainerContext;

var _react = _interopRequireWildcard(require("react"));

var _reactNativeReanimated = require("react-native-reanimated");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const NestableScrollContainerContext = /*#__PURE__*/_react.default.createContext(undefined);

function useSetupNestableScrollContextValue() {
  const [outerScrollEnabled, setOuterScrollEnabled] = (0, _react.useState)(true);
  const scrollViewSize = (0, _reactNativeReanimated.useSharedValue)(0);
  const scrollableRef = (0, _react.useRef)(null);
  const outerScrollOffset = (0, _reactNativeReanimated.useSharedValue)(0);
  const containerSize = (0, _reactNativeReanimated.useSharedValue)(0);
  const contextVal = (0, _react.useMemo)(() => ({
    outerScrollEnabled,
    setOuterScrollEnabled,
    outerScrollOffset,
    scrollViewSize,
    scrollableRef,
    containerSize
  }), [outerScrollEnabled]);
  return contextVal;
}

function NestableScrollContainerProvider(_ref) {
  let {
    children
  } = _ref;
  const contextVal = useSetupNestableScrollContextValue();
  return /*#__PURE__*/_react.default.createElement(NestableScrollContainerContext.Provider, {
    value: contextVal
  }, children);
}

function useNestableScrollContainerContext() {
  const value = (0, _react.useContext)(NestableScrollContainerContext);
  return value;
}

function useSafeNestableScrollContainerContext() {
  const value = useNestableScrollContainerContext();

  if (!value) {
    throw new Error("useSafeNestableScrollContainerContext must be called within a NestableScrollContainerContext.Provider");
  }

  return value;
}
//# sourceMappingURL=nestableScrollContainerContext.js.map