"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = RefProvider;
exports.useRefs = useRefs;

var _react = _interopRequireWildcard(require("react"));

var _reactNativeReanimated = require("react-native-reanimated");

var _constants = require("../constants");

var _propsContext = require("./propsContext");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const RefContext = /*#__PURE__*/_react.default.createContext(undefined);

function RefProvider(_ref) {
  let {
    children,
    flatListRef
  } = _ref;
  const value = useSetupRefs({
    flatListRef
  });
  return /*#__PURE__*/_react.default.createElement(RefContext.Provider, {
    value: value
  }, children);
}

function useRefs() {
  const value = (0, _react.useContext)(RefContext);

  if (!value) {
    throw new Error("useRefs must be called from within a RefContext.Provider!");
  }

  return value;
}

function useSetupRefs(_ref2) {
  let {
    flatListRef: flatListRefProp
  } = _ref2;
  const props = (0, _propsContext.useProps)();
  const {
    animationConfig = _constants.DEFAULT_PROPS.animationConfig
  } = props;
  const propsRef = (0, _react.useRef)(props);
  propsRef.current = props;
  const animConfig = { ..._constants.DEFAULT_PROPS.animationConfig,
    ...animationConfig
  };
  const animationConfigRef = (0, _react.useRef)(animConfig);
  animationConfigRef.current = animConfig;
  const cellDataRef = (0, _react.useRef)(new Map());
  const keyToIndexRef = (0, _react.useRef)(new Map());
  const containerRef = (0, _reactNativeReanimated.useAnimatedRef)();
  const flatlistRefInternal = (0, _reactNativeReanimated.useAnimatedRef)();
  const flatlistRef = flatListRefProp || flatlistRefInternal;
  const scrollViewRef = (0, _reactNativeReanimated.useAnimatedRef)(); // useEffect(() => {
  //   // This is a workaround for the fact that RN does not respect refs passed in
  //   // to renderScrollViewComponent underlying ScrollView (currently not used but
  //   // may need to add if we want to use reanimated scrollTo in the future)
  //   //@ts-ignore
  //   const scrollRef = flatlistRef.current?.getNativeScrollRef();
  //   if (!scrollViewRef.current) {
  //     //@ts-ignore
  //     scrollViewRef(scrollRef);
  //   }
  // }, []);

  const refs = (0, _react.useMemo)(() => ({
    animationConfigRef,
    cellDataRef,
    containerRef,
    flatlistRef,
    keyToIndexRef,
    propsRef,
    scrollViewRef
  }), []);
  return refs;
}
//# sourceMappingURL=refContext.js.map